diff --git a/src/transport/tcp/tcp.c b/src/transport/tcp/tcp.c
index fed8872c..d76e2450 100644
--- a/src/transport/tcp/tcp.c
+++ b/src/transport/tcp/tcp.c
@@ -993,12 +993,16 @@ tcptran_ep_get_recvmaxsz(void *arg, void *v, size_t *szp, nni_opt_type t)
 static int
 tcptran_ep_set_recvmaxsz(void *arg, const void *v, size_t sz, nni_opt_type t)
 {
-	tcptran_ep *ep = arg;
-	size_t      val;
-	int         rv;
+	tcptran_ep *  ep = arg;
+	tcptran_pipe *p;
+	size_t        val;
+	int           rv;
 	if ((rv = nni_copyin_size(&val, v, sz, 0, NNI_MAXSZ, t)) == 0) {
 		nni_mtx_lock(&ep->mtx);
 		ep->rcvmax = val;
+		NNI_LIST_FOREACH (&ep->pipes, p) {
+			p->rcvmax = val;
+		}
 		nni_mtx_unlock(&ep->mtx);
 	}
 	return (rv);
diff --git a/tests/CMakeLists.txt b/tests/CMakeLists.txt
index 031c15cd..c3de87a6 100644
--- a/tests/CMakeLists.txt
+++ b/tests/CMakeLists.txt
@@ -155,6 +155,7 @@ add_nng_test(pollfd 5)
 add_nng_test(reconnect 5)
 add_nng_test1(resolv 10 NNG_STATIC_LIB)
 add_nng_test(scalability 20 ON)
+add_nng_test(set_recvmaxsize 2)
 add_nng_test2(sha1 5 NNG_STATIC_LIB NNG_SUPP_SHA1)
 add_nng_test(sock 5)
 add_nng_test1(stats 5 NNG_ENABLE_STATS)
diff --git a/tests/set_recvmaxsize.c b/tests/set_recvmaxsize.c
new file mode 100644
index 00000000..27324c2a
--- /dev/null
+++ b/tests/set_recvmaxsize.c
@@ -0,0 +1,40 @@
+// Copyright 2018 Cody Piersall <cody.piersall@gmail.com>
+//
+// This software is supplied under the terms of the MIT License, a
+// copy of which should be located in the distribution where this
+// file was obtained (LICENSE.txt).  A copy of the license may also be
+// found online at https://opensource.org/licenses/MIT.
+//
+
+#include "convey.h"
+
+#include "nng.h"
+#include "protocol/pair1/pair.h"
+
+#define SNDBUFSIZE 150
+#define RCVBUFSIZE 200
+
+
+TestMain("SURVEY pattern", {
+	// we don't actually care what the content of the message is.
+	char msg[SNDBUFSIZE];
+	char rcvbuf[RCVBUFSIZE];
+	size_t rcvsize = RCVBUFSIZE;
+	const char *addr = "tcp://127.0.0.1:43895";
+	nng_socket s0;
+	nng_socket s1;
+	nng_listener l;
+
+	Convey("recvmaxsize can be set after listening with tcp", {
+		So(nng_pair1_open(&s0) == 0);
+		So(nng_setopt_ms(s0, NNG_OPT_RECVTIMEO, 100) == 0);
+		So(nng_setopt_size(s0, NNG_OPT_RECVMAXSZ, 200) == 0);
+		So(nng_listen(s0, addr, &l, 0) == 0);
+		So(nng_setopt_size(s0, NNG_OPT_RECVMAXSZ, 100) == 0);
+
+		So(nng_pair1_open(&s1) == 0);
+		So(nng_dial(s1, addr, NULL, 0) == 0);
+		So(nng_send(s1, msg, 150, 0) == 0);
+		So(nng_recv(s0, rcvbuf, &rcvsize, 0) == NNG_ETIMEDOUT);
+	});
+})
